﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using UCNotifier;
using ComPort;

namespace HWDcMotorController
{
	public class CCommandlist 
	{
    private CHardwareDevice FHardwareDevice;
		private CNotifier FNotifier;
		private List<CCommand> FList;

    public CCommandlist(CHardwareDevice hardwaredevice)
		{
      FHardwareDevice = hardwaredevice;
			FList = new List<CCommand>();
		}

    public CHardwareDevice HardwareDevice
    {
      get { return FHardwareDevice; }
    }

		public Int32 Count
		{
			get { return FList.Count; }
		}

		public void SetNotifier(CNotifier notifier)
		{
			FNotifier = notifier;
		}

    public Boolean Add(CCommand command)
    {
      // debug FNotifier.Write("Add Command: " + command.ToString());
      FList.Add(command);
      if (1 == Count)
      {
        command.Activate(SelfOnEnd);
      }
      return true;
    }

    public Boolean Start()
    {
      if (1 <= Count)
      {
        CCommand Command = FList[0];
        Command.Activate(SelfOnEnd);
      }
      return true;
    }

    public Boolean Abort()
		{
			CCommand Command = null;
			if (0 < Count)
			{
				Command = FList[0];
				if (Command is CCommand)
				{
					Command.Abort();
				}
			}
			FList.Clear();
			// Console.WriteLine("Abort " + FList.Count);
			return (0 == FList.Count);
		}

    //????????????????????????????????????????????????????????????
    //????????????????????????????????????????????????????????????
    //????????????????????????????????????????????????????????????
    public void SelfOnSerialDataReceived(CStringList stringlist)
    {
      // !!!!!!!!!!!!??? FHardwareDevice.OnSerialDataReceived(stringlist);
    }
    //????????????????????????????????????????????????????????????
    //????????????????????????????????????????????????????????????
    //????????????????????????????????????????????????????????????
    //????????????????????????????????????????????????????????????
    //????????????????????????????????????????????????????????????


		public void SelfOnEnd(CCommand command)
		{
      String Line = "";
      //!!!!!!!!!!String Line = String.Format("Commandlist.SelfOnEnd[{0}]", command.ToString());
      //!!!!!!!!!!FNotifier.Write(Line);
			if (0 < Count)
			{
				if (ECommandState.End == command.State)
				{
          Line = String.Format("RemoveCommand[{0}]", command.ToString());
          FNotifier.Write(Line);
          FList.Remove(command);
					if (0 < Count)
					{
						CCommand Command = FList[0];
						if (Command is CCommand)
						{
              Line = String.Format("ActivateCommand[{0}]", Command.ToString());
              FNotifier.Write(Line);
              Command.Activate(SelfOnEnd);
            }
					}
				}
			}
		}

    /*public void SetOnLineReceived(DOnLineReceived onlinereceived)
    {
      FLibrary.SetOnLineReceived(onlinereceived);
    }*/

    public void SetOnSerialDataReceived(DOnSerialDataReceived onserialdatareceived)
    {
      // <- Parent!!! FHardwareDevice.SetOnSerialDataReceived(onserialdatareceived);
    }

    public void SetOnTxDataTransmitted(DOnSerialDataTransmitted onserialdatatransmitted)
    {
      // <- Parent!!! FHardwareDevice.SetOnSerialDataTransmitted(onserialdatatransmitted);
    }

	}
}
